--------------------------------------------------------------
--                                                          --
-- Rome:Total War import/export script for CAS file format	--
-- by Vercingetorix (pauldls@hotmail.com)        			--
--                                                          --
--						Ave Caesar						    --                                                                 
--    	     	 Senatvs Popvlvsqve Romanvs  			    --
--                                                          --
--------------------------------------------------------------
--------------------------------------------------------------
--Please do not distribute in part or full any code without --
--my permission.If you have found a bug and writtin a fix   --
--please email me so I may include the fix in future release--
--do not however distribute the fix.						--
--------------------------------------------------------------
--Current version: 0.40b--
--Last Updated: 10/19/04--
--Notes: import in beta --
--Notes: export in beta --
--------------------------------------------------------------
fn getPath bLeaveLastSlash inString=(
	lastSlash=0
	outString=""
	for i=1 to inString.count do if(inString[i]=="\\") then lastSlash=i
	if bLeaveLastSlash then lastSlash-=1
	for i=1 to lastSlash do
	outString += inString[i]
	return outString
)
fn stripExt  inString=(
	lastDot=0
	outString=""
	for i=1 to inString.count do if(inString[i]==".") then lastDot=i
	for i=1 to lastDot-1 do
	outString += inString[i]
	return outString
)
fn getName inString=(
	lastSlash = 0
	outString=""
	for i=1  to inString.count do if(inString[i]=="\\") then lastSlash=i
	for i=lastSlash+1 to inString.count do
	outString += inString[i]
	return outString
)
fn uppercase instring = ( local upper, lower, outstring -- 
upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ" 
lower="abcdefghijklmnopqrstuvwxyz" 
outstring=copy instring 
for i=1 to outstring.count do 
( j=findString lower outstring[i]  
if (j != undefined) do outstring[i]=upper[j] 
) 
outstring 
) 
fn padBytes fp num=(
  for i=1 to num do WriteByte fp 0
)
fn writeVec fp outVec=(
	WriteFloat fp outVec.x
	WriteFloat fp outVec.y
	WriteFloat fp outVec.z
)
struct RTWBonelist ( name, parent, pos,rpos)

fn recursiveHeir rchild blist=(
	numBones=0
	k=1

	if ( findString rchild.name "bone" )!=undefined or ( findString rchild.name "Scene Root" )!=undefined
	then append blist ( RTWBonelist name:rChild.name  )
	if(rchild!=undefinded) then
	while(rChild.children[k]!=undefined ) do (
	numBones+=(recursiveHeir rChild.children[k] bList) +1
	k+=1
	)
	
	return numBones
			
)
struct CASHEADER(
--Start Header--
fileversion,--float, most recent is 3.20 down to 2.14
fileH,
offsetTillNextChunk1,
offsetTillNextChunk2,

	fn Read fp =(
		fileversion	= ReadFloat fp
		if fileVersion<3.05 then ( MessageBox ("Importer has detected that the file you are importing is an older version of the format is is likly to cause problems. ")   title:"Warning" beep:false
								if (queryBox "Continue anyway?")==false then return false
								)
		offsetTillNextChunk1 = ReadLong fp
		fseek fp (offsetTillNextChunk1-4)  #seek_cur -- unkown
		holdpos = ftell fp
		fseek fp 16 #seek_set
		fileH = ReadLong fp
		fseek fp holdpos #seek_set
		offsetTillNextChunk2= ReadLong fp
		fseek fp 4  #seek_cur -- unkown
		return true
	),
	fn Write fp =(
	WriteFloat fp 3.18
	WriteLong fp 38
	WriteLong fp 9
	WriteLong fp 0
	WriteFloat fp 3.3333
	WriteLong fp 1
	WriteLong fp 0
	WriteLong fp 23619688
	PadBytes fp 10
	)
	
)
-- 
--declare it global cuz it's got usefull info--
global GlobalHeader = CASHEADER 0
global MINSUPPORTEDFILEVERSION = 3.12 --what i've tested for
--convert coord sys max x = -x; max y = -z; max z = y
fn rtw2maxVector inxyz=(
		return (point3 -inxyz.x -inxyz.z inxyz.y)
		)
fn max2RtwVector inxyz=(
		return (point3 -inxyz.x inxyz.z -inxyz.y)
		)


struct RTWMESH (
bReadTv, --read textureverts?
bReadVc, --read vertex colors?
readVertAsign,--bool, wheter to read vertex assignments
verts,--array of point3 float's
normals,--array of point3 float's
faces1,--array of point3 short's
uvw1,--array of point3 float's
vc1,--vertex colors
vertAssign,
	
	fn Read fp numVerts numFaces=(
	vertAssign = #()
	verts = #()
	faces1 = #()
 	normals = #()
	uvw1	= #()
	vc1		= #()
	
	if (readVertAsign) then
	for i=1 to numverts do append vertAssign (ReadLong fp)
	
	for k=1 to numVerts do
	append verts (rtw2maxVector( ( point3 (ReadFloat fp) (ReadFloat fp) (ReadFloat fp) ) ) )
	for k=1 to numVerts do 
	append normals ( rtw2maxVector( (point3 (ReadFloat fp) (ReadFloat fp) (ReadFloat fp) ) ) )
	
	--print "verts"
	--print verts
	--print "normals"
	--print normals
	print ("Numfaces read " + (ftell fp) as string)
	for k=1 to numFaces do 
	append faces1 (point3 ((ReadShort fp)+1) ((ReadShort fp)+1) ((ReadShort fp)+1) )
	--reverse
	for k=1 to numFaces do(
	tmp = faces1[k].x
	faces1[k].x = faces1[k].z
	faces1[k].z = tmp
	)
	unknown_i1 = ReadLong fp--usally zero
	if bReadTv!=0 then for k=1 to numVerts do append uvw1 ( (point3 (ReadFloat fp) (1.0-(ReadFloat fp)) 0.0) )
	
	--FFcheck = ReadLong fp --another hack, damn :p
	--fseek fp -4 #seek_cur
	--if(GlobalHeader.fileVersion >= MINSUPPORTEDFILEVERSION) then 
	if(bReadVc!=0)then --FFcheck<=-1
	for k=1 to numVerts do --colors 
		append vc1  (ReadLong fp #unsigned) 
	
	)
)
struct GEOM_CHUNK_T(--type 
type,--1 or 2
nameLength,--dword
name,--null terminated string
boneAttached,--dword, bone attached to
numVerts,--short, number of vertices
numFaces,--short, number of triangles
mesh1,--RTWMESH
newObj,

	fn Read fp  =(
	
	nameLength=ReadLong fp
	name = ReadString fp
	print ("At offset " + (ftell fp) as string)
	print ("Importing mesh " +name)
	
	if(GlobalHeader.fileVersion >= 3.05 or type==1) then (
	strSkip=ReadLong fp--length of extra string
	fseek fp strSkip #seek_cur
		)
	 
	if (type ==1) then (--fseek fp 6 #seek_cur--3 shorts?
				if(GlobalHeader.fileVersion >= 3.05) then(
				   strSkip2=ReadLong fp--length of extra string
				   fseek fp strSkip2 #seek_cur
				   )
				   boneAttached=ReadLong fp
				   fseek fp 28 #seek_cur)--7 floats likly minBox maxBox radius
	else if(type==2) then fseek fp 28 #seek_cur
	
	numVerts=ReadShort fp
	numFaces=ReadShort fp
	print("numverts: " +numverts as string )
	print("numfaces: " +numfaces as string )
	bReadTv = ReadByte fp #unsigned
	bReadVc = ReadByte fp #unsigned
	mesh1 = RTWMESH bReadTv:bReadTv  bReadVc:bReadVc
	if(type==1) then mesh1.readVertAsign = false
	else if(type == 2) then mesh1.readVertAsign = true
	mesh1.read fp numVerts numFaces
	
	--create mesh
	 newObj = mesh name:name   vertices:mesh1.verts faces:mesh1.faces1 tverts:mesh1.uvw1
		--for i=1 to mesh1.normals.count do setNormal newObj i mesh1.normals[i]
		
		defaultVCFaces newObj --buildVCFaces newObj
		if bReadTv!=0 then (
		for k=1 to numverts do
		SetTVert newObj k mesh1.uvw1[k]
			
		buildTVFaces newObj
		ind = 0
		for k=1 to numfaces do( 
		ind += 1
		SetTVFace newObj ind mesh1.faces1[ind]
		--SetVCFace newObj ind vc1[ind]
			)
		)
	),
	
	fn Write fp gemT bList =(
	print ("Exporting mesh " +gemT.name)
	WriteLong fp (gemT.name.count+1)
	WriteString fp gemT.name
	WriteLong fp 1
		WriteByte fp 0
		if(type==1) then (
		WriteLong fp 1
		WriteByte fp 0
		for i=1 to bList.count do if bList[i].name==gemT.parent.name then boneAttached=i-1
		WriteLong fp boneAttached
		)
		tmpMesh = snapshot gemT
		if(type==1) then(
		minBox = max2RtwVector(gemT.min-gemT.parent.pos)
		maxBox = max2RtwVector(gemT.max-gemT.parent.pos)
			)
		else (
			minBox = point3 0 0 0
			maxBox = point3 0 0 0
			)
		writeVec fp minBox
		writeVec fp maxBox
		WriteFloat fp ( (distance minBox maxBox)/2.0)
		numVerts = getNumVerts tmpMesh
		numFaces = getNumFaces tmpMesh
		cfgShort = 257
		
		WriteShort fp numVerts
		WriteShort fp numFaces
		WriteShort fp cfgShort
		
		vertAssign = #()
		verts = #()
		faces1 = #()
 		normals = #()
		uvw1	= #()


		if(type==2) then(
			if gemT.modifiers["Skin"]==undefined or gemT.modifiers[1].name!="Skin" then ( MessageBox ("Mesh " + gemT.name + " must have the skin modifier at the top of the stack. If it is static then it must have a bone as it's parent")   title:"Error!" beep:false
			delete tmpMesh
			return false )
			
			select gemT
			max modify mode
			for i=1 to numVerts do for k=1 to (skinOps.GetVertexWeightCount gemT.modifiers[1] i) do if((skinOps.GetVertexWeight gemT.modifiers[1] i k)>0.9) then append vertAssign (skinOps.GetVertexWeightBoneId gemT.modifiers[1] i k)
			--print vertassign --for k=1 to (skinOps.GetNumberbones gemT.modifiers[1]) do
			vertAssign1 = #()
			
			for i=1 to numVerts do if vertAssign[i]==undefined then ( MessageBox ("Problem occured while reading the vertex wieghts of vertex " + ( (i-1) as string) +" in mesh " + gemT.name + " . Make sure each vertex has exactly 1 bone weight")   title:"Error!" beep:false
			delete tmpMesh
			return false )
			
			for i=1 to numVerts do  for j=1 to bList.count do if bList[j].name==(skinOps.getBoneName gemT.modifiers[1] vertAssign[i] 1) then  append vertAssign1 (j-1)
			

			for i=1 to numVerts do WriteLong fp vertAssign1[i]
			)
			
		if (type==2) then for i=1 to numVerts do writeVec fp (  max2RtwVector ( in coordsys world (getVert tmpMesh i) - bList[vertAssign1[i]+1].pos) )
		if type==1 then for i=1 to numVerts do writeVec fp (  max2RtwVector ( (in coordsys world (getVert tmpMesh i) ) - gemT.parent.pos) )
		
		for i=1 to numVerts do writeVec fp (  max2RtwVector (  getNormal tmpMesh i) )
		
		for k=1 to numFaces do(
		tface = getFace tmpMesh k
		WriteShort fp (tface.z-1)
		WriteShort fp (tface.y-1)
		WriteShort fp (tface.x-1)
		)
		PadBytes fp 4
		for i=1 to numVerts do(
			ttVert = point3 0.0 0.0 0.0
			for k=1 to numFaces do(
			tface = getFace tmpMesh k
			if tface.x==i then ttVert = gettvert tmpMesh (getTVFace tmpMesh k).x
			else if tface.y==i then ttVert = gettvert tmpMesh (getTVFace tmpMesh k).y
			else if tface.z==i then ttVert = gettvert tmpMesh (getTVFace tmpMesh k).z

			)

			--ttVert = gettvert tmpMesh i
			WriteFloat fp ttVert.x
			WriteFloat fp (1.0-ttVert.y)
			)
		for i=1 to numVerts do  WriteLong fp -1
		delete tmpMesh
		return true
	)
		
)
struct GEOM_CHUNK(
offsetTillNextChunk3,
chunkType,--dword
numMeshes,--dword
geomChunks,--array of meshes
tmpMesh,
	
	fn Read fp  =(
	offsetTillNextChunk3 = ReadLong fp
	chunkType= ReadLong fp
	print chunkType
	numMeshes= ReadLong fp
	--if(numMeshes==0) then  fseek fp 6 #seek_cur
	tmpMesh = #()
	geomChunks = #()
		for i=1 to numMeshes do(
		if(chunktype==2 ) then tmpMesh = GEOM_CHUNK_T 2 
		else if(chunktype==1) then tmpMesh = GEOM_CHUNK_T 1
		else return 0
		
		tmpMesh.Read fp
		append geomChunks tmpMesh
		if(GlobalHeader.fileVersion >= 3.16) then zeroMarker = ReadLong fp else zeroMarker = ReadByte fp
		
		
		
		)
	print ("End read" + (ftell fp) as string)
	return true
	),
	
	fn Write fp gemSet bList =(
	posSave = ftell fp
	WriteLong fp -1 --save spot 
	WriteLong fp chunkType
	WriteLong fp gemSet.count
	for i=1 to gemSet.count do(
		if(chunktype==2 ) then tmpMesh = GEOM_CHUNK_T 2 
		else if(chunktype==1) then tmpMesh = GEOM_CHUNK_T 1
		else return 0
		
		if(tmpMesh.Write fp gemset[i] bList)==false then return false
		PadBytes fp 4
		)
	if(chunktype==1)then WriteShort fp 0
	WriteLong fp gemSet.count
	currentPos = ftell fp
	fseek fp posSave #seek_set
	WriteLong fp (currentPos-posSave)
	fseek fp currentPos #seek_set
	return true
	)
)
struct FRAMEVECTOR(
rot,--point3 rotation x y z, 
scale,--float
quat1,--quat rotation
	fn Read fp=(
	rot =    ( point3 (ReadFloat fp) (ReadFloat fp) (ReadFloat fp) )  --)--rtw2maxVector( 
	scale=RadToDeg(ReadFloat fp)
	quat1 = quat scale (point3 rot.x -rot.z rot.y)  --scale --scale rot--
	
	)

)

struct RTWBONE(
strLen, --dword
boneName, --null terminated
numFrames,--numberOfFrames stored
unknownL1, --usally 0
offsetStart,--where it's vectors start
offsetEnd,--offset untill the bone position?
strSize,--usally 1, for storing extra info i think
unkownL2,--usally 0
position, --point3
fn Read1 fp =(--phase1 read
	strLen = ReadLong fp
	boneName 	= ReadString fp
	numFrames	= ReadLong fp
	unkownL1	= ReadLong fp
	offsetStart	= ReadLong fp
	offsetEnd	= ReadLong fp
	unkownL2	= ReadLong fp
	if(GlobalHeader.fileVersion >= 3.16) then(
	strSize		= ReadLong fp
	fseek fp strSize  #seek_cur
	)
	print (ftell fp) 
	),
	fn Read2 fp =(--phase2 read
	position = rtw2maxVector( point3 (ReadFloat fp) (ReadFloat fp) (ReadFloat fp) )
	--scale=(ReadFloat fp)
	)

)

struct BONESCHUNK (
pBones,--or point bone list
numBones,
boneList, --list of the bone names

	fn Read fp =(
		numBones = ReadLong fp
		if(GlobalHeader.fileVersion >= 3.05) then
		fseek fp 2  #seek_cur --usally 0
		else fseek fp 1  #seek_cur
		
		print numBones
		print (ftell fp)
		boneHier = #()
		for i=1 to numbones-1 do
		append boneHier (ReadLong fp )
		numFrames = ReadLong fp
		fseek fp (numFrames*4) #seek_cur--frame info, time
			
		vbones = #()
		for i=1 to numbones do(
		tmpBone = RTWBONE 0 
		tmpBone.Read1 fp
		append vbones tmpBone
		print tmpBone.boneName
		)
		--fseek fp 24  #seek_cur -- unkown, usally 0's
		boneVectors = #()
		animationSet = #()
		
		--append boneVectors (point3 0.0 0.0 0.0)
		angles  = FRAMEVECTOR (point3 0.0 0.0 0.0) 1.0
		append animationSet angles
		append boneVectors animationSet[1]
		
		for i=2 to numbones do
		if (vbones[i].numFrames>0) then (
		animationSet = #()
		for k=1 to vbones[i].numFrames do (
		tmpFVector = FRAMEVECTOR 0
		tmpFVector.Read fp
		append animationSet tmpFVector
		--angles = rtw2maxVector( point3 (ReadFloat fp) (ReadFloat fp) (ReadFloat fp) )	
		
		--fseek fp (((numFrames-1)*16)+4) #seek_cur --skip all the bone info for now
			 )
		append boneVectors animationSet
			)
			
		rootAnims= (ftell fp)
		if(numbones>1) then
		fseek fp (vbones[2].numFrames*12) #seek_cur --unkown point3's

		else fseek fp (vbones[1].numFrames*12) #seek_cur
		
		--print ("pos" + (ftell fp) as string)
		
		for i=1 to numbones do
			vbones[i].Read2 fp
			pbones= #()
			p = point pos:vbones[1].position --
			p.size = 0.1
			p.showLinks=true
			p.name = vbones[1].boneName 
			append pbones p
			bSwitch=false--change in heirarchy
		for i=2 to numbones do(
			--boneSys.createBone  vbones[index].position vbones[i].position (point3 0 0 0)
			index=boneHier[i-1]+1
			
			--print index
			
			in pbones[index] p = point pos:(vbones[i].position+pbones[index].pos)
			p.name = vbones[i].boneName 
			p.size = 0.1
			p.showLinks=true
			append pbones p
			)
		),--End Read
		
	fn Write fp =(
	rootBone = getNodeByName "Scene Root"
	if rootBone==undefined then (
		MessageBox "Cannot export without the Scene Root bone. Verify it exists." title:"Error!" beep:false
		return false
		)
	WriteLong fp -1 --offset to the geometry chunk. i'll beh back =)
	WriteLong fp 0 
	numBones =1
	boneList = #()
	numBones = recursiveHeir rootBone boneList
	numBones = boneList.count
	
	boneList[1].parent=1 
	boneList[1].rpos=(point3 0.0 0.0 0.0) 
	
	for i=2 to boneList.count do 
	for k=1 to boneList.count do if (getNodeByName boneList[i].name).parent.name == boneList[k].name then boneList[i].parent = k
	for i=2 to boneList.count do (boneList[i].pos = (getNodeByName boneList[i].name).pos 
					boneList[i].rpos = boneList[i].pos-(getNodeByName boneList[boneList[i].parent].name).pos
					)
	print ("Numbones: " + boneList.count as string)
	print boneList
	
	WriteShort fp numBones 
	for i=1 to boneList.count do WriteLong fp (boneList[i].parent-1)
	WriteLong fp 68
	for i=0 to 67 do WriteFloat fp (i*0.05)
	for i=1 to numBones do (
		WriteLong fp (boneList[i].name.count+1)
		WriteString fp  boneList[i].name
		padBytes fp 20
		WriteLong fp 1
		WriteByte fp 0
		)
	for i=1 to numBones do (
	boneList[i].rpos = max2RtwVector boneList[i].rpos
	WriteFloat fp boneList[i].rpos.x
	WriteFloat fp boneList[i].rpos.y
	WriteFloat fp boneList[i].rpos.z
		)
	currentPos=ftell fp
	fseek fp 42 #seek_set
	WriteLong fp (currentPos-42)
	fseek fp currentPos #seek_set
	return true--all is well
	)
		
)

utility CASIE "R:TW Import/Export" silentErrors:false rolledup:true(
group "About:"
	(
		label titleLabel	"Rome:Total War script v0.40b"
		HyperLink addy "by Vercingetorix" align:#center address:"mailto:pauldls@hotmail.com" color:(color 0 0 170) hoverColor:(color 170 0 0)
	)
group "Web Links:"
	(
		HyperLink link0 "Check for Updates!" align:#center address:"http://www.stratcommandcenter.com/editor" color:(color 0 0 160) hoverColor:(color 170 0 0)
		HyperLink link1 "TWCenter" align:#center address:"http://www.twcenter.net" color:(color 0 0 160) hoverColor:(color 170 0 0)
		HyperLink link2 "TWOrg" align:#center address:"http://www.totalwar.org" color:(color 0 0 160) hoverColor:(color 170 0 0)
		HyperLink link3 "TWCom" align:#center address:"http://www.totalwar.com" color:(color 0 0 160) hoverColor:(color 170 0 0)

	)
------------------------
--Begin Export rollout--
------------------------
rollout CASExport "R:TW Export"  rolledUp:false

(
	 	
	--------------------
	-- User Interface --
	--------------------

	
	
	group "Options:"
	(
		radiobuttons tagAction "Objects:" labels:#("Export Selection", "Export all") default:2
	)
	
	group "Export:"
	(
		

		

		
		button exportButton "Export CAS..."	
	)
	
	
	
	-------------
	-- UI Bits --
	-------------
	
	
	on exportButton pressed do 
	(
		
		local importPly fname = getSaveFileName types:"CAS (*.cas)|*.cas|All (*.*)|*.*|"
		if fname == undefined then return NULL
		fp =  fopen fname "wb"
		--Write Out header
		header = CASHEADER()
		header.write fp
		bChunk = BONESCHUNK()
		if (bchunk.write fp)==false then return 1
		staticmArray = #()
		dynamicArray = #()
		if(tagAction.state==2) then
		for i=1 to geometry.count do if(geometry[i].parent!=undefined) then append staticmArray geometry[i] else append dynamicArray geometry[i]
		else if(tagAction.state==1) then
		for i=1 to selection.count do if(selection[i].parent!=undefined) then append staticmArray selection[i] else append dynamicArray selection[i]
		
		if(staticmArray.count>0) then (
		gChunk1= GEOM_CHUNK chunktype:1
		if(gChunk1.write fp staticmArray bChunk.boneList)==false then return 1
		)
		if(dynamicArray .count>0) then(
		gChunk2= GEOM_CHUNK chunktype:2
		if(gChunk2.write fp dynamicArray bChunk.boneList)==false then return 1
		)
		tCheck = if (tagAction.state==2) then selection else geometry
		if tCheck[1].material==undefined or tCheck[1].material.diffuseMap.filename==undefined then messageBox "Failed to locate texture. Make sure each mesh has a material assigned to it and has a diffuse map bitmap" title:"Error!" beep:false
		else (--write out textures
		texName = "\\textures\\" + (getName tCheck[1].material.diffuseMap.filename)
		if (findString texName ".DDS")!=undefined then texName = stripExt texName
		WriteLong fp 16
		WriteLong fp 3
		padBytes fp 8
		WriteLong fp 16
		WriteLong fp 8
		padBytes fp 8
		WriteLong fp 16
		WriteLong fp 10
		padBytes fp 8
		
		WriteLong fp (75+texName.count)
		WriteLong fp 5
		WriteLong fp 1
		WriteLong fp 1
		WriteByte fp 0
		WriteString fp texName
		for i=1 to 7 do WriteFloat fp 1.0
		padBytes fp 28
		WriteByte fp 1
		
		)
		print "Export completed successfully!"
		fclose fp
		
    )
	
)


------------------------
--Begin Import rollout--
------------------------
rollout CASImport "R:TW Import"  rolledUp:false

(
	

	

	global g_gameDataPath = ""
	global g_defaultGameDataPath = "D:\\Program Files\\Activision\\Rome - Total War\\Data\\models_unit"
	--global GlobalHeader = CASHEADER 0
	-- Useful file information
	local modelFilename
	local modelPath



	--------------------
	-- User Interface --
	--------------------

	
	
	group "Options:"
	(
		edittext pakDirEdit "Textures Path:" text:"** Not Set **" readonly:true
		button setPakRootButton "Set Textures Folder Path"
	)
	
	group "Import:"
	(
		radiobuttons tagAction "Textures:" labels:#("Ignore all", "Load all") default:2

		checkbox promptForMissing "Force textures path" checked:false

		
		button importButton "Import CAS..."	
	)
	

	local recentFile

	fn AddRecentFile fname=
	(
		recentFile = fname
		ok
	)
	
	
	-------------
	-- UI Bits --
	-------------
	
	fn UpdateUI=
	(
		local theDir = g_gameDataPath
		if theDir == undefined do
		(
			theDir = "** Not Set **"
		)
		pakDirEdit.text = theDir
	
	)
		
	on CASImport open do
	(
				
		if g_gameDataPath == "" then
		(
			g_gameDataPath = g_defaultGameDataPath
		)
	
		UpdateUI()
	)
	on pakDirEdit entered newText do
	(
		g_gameDataPath = newText
	)
	
 	on setPakRootButton pressed do
	(
		local newPakDir = getSavePath caption:"Set Game Data Path"
		if newPakDir != undefined do
		(
			g_gameDataPath = newPakDir
			UpdateUI()
		)
	)


	
on importButton pressed do --import
	(
local importPly fname = getOpenFileName types:"CAS (*.cas)|*.cas|All (*.*)|*.*|"
		if fname == undefined then return NULL
		fp =  fopen fname "rb"
		
		--Read Header--
		
		if not (GlobalHeader.read fp) then return 1
		--Read Bones--
		bChunk = BONESCHUNK()
		bChunk.Read fp 
		
			--frames
		/* i dunno what this is really  -will need to get back to it
		if(numbones>1) then (
		fseek fp rootAnims #seek_set
		animate on for i=1 to vbones[2].numFrames do
		at time i pbones[2].pos =  point3 (ReadFloat fp) (ReadFloat fp) (ReadFloat fp)
		--fseek fp (vbones[2].numFrames*12) #seek_cur --unkown point3's
		)
		*/
		--local importPly fname2 = getOpenFileName types:"CAS (*.cas)|*.cas|All (*.*)|*.*|"
		--if fname2 == undefined then return NULL
		
		/*--ANIMATION ON HOLD
		fname2 = "G:\\3ds max\\scripts\\RTW\\animtest"
		fp2 = fopen fname2 "rb"
		numFrames=ReadShort fp2
		numBones1=ReadShort fp2
		fseek fp2 1 #seek_cur
		

		boneVecs = #()
		for i=1 to numFrames do (
		animSet = #()
		for k=1 to numBones1 do (
		tmpFVector = FRAMEVECTOR 0
		tmpFVector.Read fp2

		--print (length( tmpFVector.rot) )
		append animSet tmpFVector
			 )
		append boneVecs  animSet
			)
		
		
		print ("pos2 " + (ftell fp2) as string)
		for k=1 to numFrames do	animate on at time k pbones[2].position = rtw2MaxVector (point3 (readfloat fp2) (readfloat fp2) (readfloat fp2) )
		for k=2 to numBones1+1 do (
 		tmpV= point3 (readfloat fp2) (readfloat fp2) (readfloat fp2) 
		animate on at time 0 in coordsys pbones[k].parent pbones[k].rotation.x_rotation=RadtoDeg(tmpV.x)
		animate on at time 0 in coordsys pbones[k].parent pbones[k].rotation.y_rotation=RadtoDeg(tmpV.z)
		animate on at time 0 in coordsys pbones[k].parent pbones[k].rotation.z_rotation=RadtoDeg(tmpV.y)
		)
		--return 1
		animate on for i=2 to numbones  do 
		if (vbones[i].numFrames>0) then 
		for k=1 to numFrames do in coordsys pbones[i].parent(--vbones[i].numFrames
		angles=eulerAngles (RadToDeg(boneVecs[k][i-1].rot.x)) (RadToDeg(boneVecs[k][i-1].rot.y)) (RadToDeg(boneVecs[k][i-1].rot.z))
		--pbones[i].rotation.controller = Controller_TCB()
		--at time k in coordsys pbones[i].parent pbones[i].rotation= angles
		--at time k in coordsys pbones[i].parent rotate pbones[i] angles
		
		--at time k  pbones[i].rotation=   boneVecs[k][i-1].quat1--*(Pi/180.0)
		--if(i>2) then at time k in coordsys pbones[i].parent  pbones[i].rotation*= pbones[i].parent.rotation
		--boneVecs[k][i-1].rot=normalize boneVecs[k][i-1].rot
		--pbones[i].rotation.controller = Local_Euler_XYZ()
		
		at time k  pbones[i].rotation.x_rotation = RadToDeg(boneVecs[k][i-1].rot.x) +pbones[i].parent.rotation.x_rotation
		at time k  pbones[i].rotation.y_rotation = RadToDeg(boneVecs[k][i-1].rot.z) +pbones[i].parent.rotation.y_rotation
		at time k  pbones[i].rotation.z_rotation = RadToDeg(boneVecs[k][i-1].rot.y) +pbones[i].parent.rotation.z_rotation
	
			if(i>211) then (
			
			--at time k   pbones[i].rotation*= pbones[i].parent.rotation

			at time k  pbones[i].rotation.x_rotation +=  pbones[i].parent.rotation.x_rotation
			at time k  pbones[i].rotation.y_rotation += pbones[i].parent.rotation.y_rotation
			at time k  pbones[i].rotation.z_rotation +=  pbones[i].parent.rotation.z_rotation

			
			)
		
		)
	
		--print ("pos" + (ftell fp) as string)
		fclose fp2
		return 0

		*/--ANIMATION ON HOLD OVER
		
		
		geomSet = GEOM_CHUNK 0		
		geomSet.Read fp
		
		--if(GlobalHeader.fileVersion >= 3.16) then 

		fseek fp 6 #seek_cur --3 shorts?
		--else fseek fp 3 #seek_cur --
		
		grabPos = ftell fp
		fseek fp 0 #seek_end
		secondMeshes =false

		if( ( (ftell fp) - grabPos) > 1024 ) then (--is this a hack or what
		secondMeshes = true
		fseek fp grabPos #seek_set
		geomSet1 = GEOM_CHUNK 0		
		geomSet1.Read fp
		)
		
		progressStart ("Setting up Mesh...")
		--print ("11111111:" + geomSet.geomChunks[2].newObj.numverts as string)
		for k= 1 to geomSet.geomChunks.count do(
		geomSet.geomChunks[k].newObj.pos +=bChunk.pbones[geomset.geomChunks[k].boneAttached+1].position
		--for i=1 to geomSet.geomChunks[k].newObj.numverts do 
		--setVert geomSet.geomChunks[k].newObj i ( (getvert  geomSet.geomChunks[k].newObj i)+pbones[geomset.geomChunks[k].boneAttached+1].position)
		convertToMesh( geomSet.geomChunks[k].newObj )
		geomSet.geomChunks[k].newObj.parent = bChunk.pbones[geomset.geomChunks[k].boneAttached+1]
		geomSet.geomChunks[k].newObj.material= getMeditMaterial 1

		)
		if secondMeshes==true then
		for k= 1 to geomSet1.geomChunks.count do(
		for i=1 to geomSet1.geomChunks[k].newObj.numverts do 
		setVert geomSet1.geomChunks[k].newObj i ( (getvert  geomSet1.geomChunks[k].newObj i)+bChunk.pbones[geomset1.geomChunks[k].mesh1.vertAssign[i]+1 ].position)
		
		convertToMesh( geomSet1.geomChunks[k].newObj )
		update geomSet1.geomChunks[k].newObj geometry:true normals:true
		geomSet1.geomChunks[k].newObj.material= getMeditMaterial 1
		--add skin
		sm = skin()
		sm.rigid_vertices = true
		select geomSet1.geomChunks[k].newObj
		max modify mode
		addModifier geomSet1.geomChunks[k].newObj sm
		for j=2 to bChunk.pbones.count do
		skinOps.addbone sm ( getNodeByName bChunk.pbones[j].name) 1
		
		for i=1 to geomSet1.geomChunks[k].newObj.numverts do(
		skinOps.SetVertexWeights sm i (geomset1.geomChunks[k].mesh1.vertAssign[i]) 1.0
		local cont = progressUpdate ( ( (i as float)/(geomSet1.geomChunks[k].newObj.numverts) )* 100)
		if NOT cont then return true
			)
		
		)
		progressEnd()
		
		--
		--Read Textures...hack
		if(tagAction.state==2) then (
		fseek fp -12 #seek_end
		extraOffset = ReadLong fp
		if extraOffset>12 or extraOffset<0 then extraOffset=0
		fileSize = (ftell fp) + 8 - extraOffset 
		while ( (ReadLong fp)-4 != (filesize-(ftell fp)) ) do if (filesize-(ftell fp)) > 1024 then return 1 else fseek fp -5 #seek_cur  --find that sucker
		print ("texture@ " +(ftell fp) as string)
		fseek fp 4 #seek_cur
		numTextures=ReadLong fp
		strSkip=ReadLong fp
		fseek fp strSkip #seek_cur
		for i=1 to numTextures do(
			print (ftell fp)
			bmpName = ReadString fp
			if( (findString bmpName "textures") == undefined) then bmpName = "\\textures" +bmpName
			bAlreadySlash= bmpName[1]=="\\"
			if( (findString bmpName ".DDS") == undefined) then bmpName+=".DDS"
			fseek fp 62 #seek_cur
			
			if (promptForMissing.checked==false) then pathName = getPath bAlreadySlash fname
			else ( if( (findString g_gameDataPath "textures") != undefined) then pathname = getPath bAlreadySlash g_gameDataPath
					else pathName = g_gameDataPath )
			
			if not bAlreadySlash and (pathName[pathName.count]!="\\") then pathName+="\\"
			fullname = pathName + (bmpName)
			tm = bitMapTexture()
			tm.filename = fullname
			print fullname
			mat = getMeditMaterial i -- -- --
			if mat==undefined then mat=standardMaterial diffuseMap:tm
			else mat.diffuseMap=tm
			showTextureMap mat tm on
			setMeditMaterial i mat
			--mat1 = getMeditMaterial i
			
			)

		)
		--We're Done, yay!
		print ("Import finished, End Pos: "  + (ftell fp) as string)
		fclose fp
		CompleteRedraw()
	)
 
 )--End Import
 on CASIE open do (
 
 	if CASExport!=undefined and CASExport.open==true then (
	removeRollout CASExport
 	addRollout CASExport rolledup:false
	)
	else addRollout CASExport rolledup:true
	
	if CASImport!=undefined and CASImport.open==true then (
	removeRollout CASImport 
	addRollout CASImport rolledup:false
	)
	else addRollout CASImport rolledup:true
	
  )
  on CASIE close do (
	removeRollout CASImport --rolledup:true
	removeRollout CASExport --rolledup:true

	
  )
)--End Utility


